<?php
namespace app\controllers;
use app\app;
use app\models\users;
use app\models\magic_links;

class magic_link
{
    public static function index()
    {
        $email = $_GET['email'] ?? null;
        $token = $_GET['token'] ?? null;
        $signup = $_GET['signup'] ?? null;

        if (empty($email) && empty($token)) {
            $_SESSION['error'] = "Enter your email to get a login link";
            header('Location: /account/login');
            exit;
        }

        if ($email && empty($token) && empty($signup)) {
            $link = magic_links::add(email: $email);
            $subject = "Your Magic Sign-In Link";
            $message = "Copy and paste the link into your browser: $link";
            $HTML_message = "Click the link to sign in: <a href='$link'>$link</a>";
            app::send_mail(to: $email, from: $_ENV['SMTP_FROM'], from_name: $_ENV['APP_NAME'], subject: $subject, message: $message, HTML_message: $HTML_message);
            $_SESSION['success'] = 'Link sent to your email!';
            header('Location: /account/login');
            exit;
        }

        if ($email && empty($token) && $signup == "1") {
            $link = magic_links::add(email: $email);
            $subject = "Your Magic Sign-In Link";
            $message = "Copy and paste the link into your browser: $link";
            $HTML_message = "Click the link to sign in: <a href='$link'>$link</a>";
            app::send_mail(to: $email, from: $_ENV['SMTP_FROM'], from_name: $_ENV['APP_NAME'], subject: $subject, message: $message, HTML_message: $HTML_message);
            $_SESSION['success'] = 'Account created! Please check your email inbox for the verification link.';
            header('Location: /account/login');
            exit;
        }

        if ($token && empty($email)) {
            $link = magic_links::validate(token: $token);

            if (!$link) {
                $_SESSION['error'] = "Invalid or expired link.";
                header('Location: /account/login');
            }
            // handle signup vs. login 
            $user = users::getByEmail($link['email']);
            if ($user) {
                $_SESSION['user_email'] = $link['email'];
                $_SESSION['user_id'] = $user['id'];
                if (!$user['verified']) {
                    users::verify($link['email']);
                }
                header('Location: /account');
            } else {
                // used to pre-fill email signup field
                $_SESSION['user_email'] = $link['email'];
                header('Location: /account/signup');
            }
            exit();
        }
    }
}
