<?php
namespace app\models;

use app\app;
class addresses
{
    public static function init()
    {
        app::$db->exec("CREATE TABLE IF NOT EXISTS addresses (
            id INTEGER PRIMARY KEY AUTOINCREMENT,
            name TEXT NOT NULL,
            company TEXT,
            street TEXT NOT NULL,
            boxapt TEXT NOT NULL,
            city TEXT NOT NULL,
            state TEXT NOT NULL,
            zip TEXT NOT NULL,
            phone TEXT,
            billing BOOLEAN NOT NULL,
            shipping BOOLEAN NOT NULL
        )");
    }

    public static function validatePost($type)
    {
        $name = $_POST["{$type}_name"];
        $company = $_POST["{$type}_company"] ?? null;
        $boxapt = $_POST["{$type}_boxapt"] ?? null;
        $street = $_POST["{$type}_street"];
        $city = $_POST["{$type}_city"];
        $state = $_POST["{$type}_state"];
        $zip = $_POST["{$type}_zip"];
        $phone = $_POST["{$type}_phone"];
        // check all required fields are set
        if (empty($name) || empty($street) || empty($city) || empty($state) || empty($zip) || empty($phone)) {
            $_SESSION['error'] = "Missing required {$type} information.";
        }
        // TODO: find a match using postal database and return that
        return [
            'name' => $name,
            'company' => $company,
            'street' => $street,
            'boxapt' => $boxapt,
            'city' => $city,
            'state' => $state,
            'zip' => $zip,
            'phone' => $phone
        ];
    }

    public static function add($name, $company, $street, $boxapt, $city, $state, $zip, $phone, $billing, $shipping)
    {
        $query = "INSERT INTO addresses (
            name, 
            company, 
            street,
            boxapt, 
            city, 
            state, 
            zip,
            phone,
            billing,
            shipping
        ) VALUES (
            :name, 
            :company, 
            :street,
            :boxapt,
            :city, 
            :state, 
            :zip,
            :phone,
            :billing,
            :shipping
        )";
        $stmt = app::$db->prepare($query);
        $stmt->bindParam(':name', $name);
        $stmt->bindParam(':company', $company);
        $stmt->bindParam(':street', $street);
        $stmt->bindParam(':boxapt', $boxapt);
        $stmt->bindParam(':city', $city);
        $stmt->bindParam(':state', $state);
        $stmt->bindParam(':zip', $zip);
        $stmt->bindParam(':phone', $phone);
        $stmt->bindParam(':billing', $billing);
        $stmt->bindParam(':shipping', $shipping);
        $stmt->execute();
        return app::$db->lastInsertId();
    }

}
