<?php
namespace app\models;

use app\app;
class transactions
{
    public static function init()
    {
        app::$db->exec("CREATE TABLE transactions (
            id INTEGER PRIMARY KEY AUTOINCREMENT,
            user_id INTEGER NOT NULL,
            type TEXT CHECK(transaction_type IN ('credit', 'spend', 'withdraw')) NOT NULL,
            cents REAL DEFAULT 0,
            sats REAL DEFAULT 0,
            date TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
            FOREIGN KEY (user_id) REFERENCES users(id)
        )");
    }

    public static function add($user_id, $transaction_type, $cents, $sats_amount)
    {
        $query = "INSERT INTO transactions (
            user_id,
            type,
            cents,
            sats
        ) VALUES (
            :user_id,
            :transaction_type,
            :cents,
            :sats
        )";
        $stmt = app::$db->prepare($query);
        $stmt->bindParam(':user_id', $user_id);
        $stmt->bindParam(':transaction_type', $transaction_type);
        $stmt->bindParam(':cents', $cents);
        $stmt->bindParam(':sats', $sats_amount);
        $stmt->execute();
        return app::$db->lastInsertId();
    }

    public static function getUserBalance($user_id)
    {
        $query = "SELECT SUM(cents) AS total_cents, 
            SUM(sats) AS total_sats 
            FROM transactions 
            WHERE user_id = :user_id";
        $stmt = app::$db->prepare($query);
        $stmt->bindParam(':user_id', $user_id);
        $stmt->execute();
        $result = $stmt->fetch();
        return $result;
    }
}
